#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_sJIK48x48x48TT0x0x0_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=48, NB=48, KB=48, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=1, ku=48, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const float *stM = A + (((lda) << 5)+((lda) << 4));
   const float *stN = B + 48;
   const float *pfA = A + M;
   #define incAk 48
   const int incAm = ((((lda) << 2)) - 48), incAn = -(((lda) << 5)+((lda) << 4));
   const int incBk = (ldb), incBm = -(((ldb) << 5)+((ldb) << 4));
   #define incBn 1
   const int incAk0 = ((incAk) / 48);
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (ldc) - 48;
   float *pC0=C;
   const float *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda);
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0;
   register float m0, m1, m2, m3, m4, m5;
   register float rC0_0, rC1_0, rC2_0, rC3_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      pfA += lda;
      do /* M-loop */
      {
         ATL_pfl1W(pC0);
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         m0 = rA0 * rB0;
         rA2 = *pA2;
         m1 = rA1 * rB0;
         rA3 = *pA3;
         m2 = rA2 * rB0;
         m3 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[1];
         rB0 = *pB0;
         rA1 = pA1[1];
         rA2 = pA2[1];
         m4 = rA0 * rB0;
         rA3 = pA3[1];
         m5 = rA1 * rB0;

/*
 *       Completely unrolled K-loop
 */
         rC0_0 = m0;
         m0 = rA2 * rB0;
         rC1_0 = m1;
         m1 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[2];
         rB0 = *pB0;
         rA1 = pA1[2];
         rA2 = pA2[2];
         rC2_0 = m2;
         m2 = rA0 * rB0;
         rA3 = pA3[2];
         rC3_0 = m3;
         m3 = rA1 * rB0;
         rC0_0 += m4;
         m4 = rA2 * rB0;
         rC1_0 += m5;
         m5 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[3];
         rB0 = *pB0;
         rA1 = pA1[3];
         rA2 = pA2[3];
         rC2_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[3];
         rC3_0 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m2;
         m2 = rA2 * rB0;
         rC1_0 += m3;
         m3 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[4];
         rB0 = *pB0;
         rA1 = pA1[4];
         rA2 = pA2[4];
         rC2_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA3[4];
         rC3_0 += m5;
         m5 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[5];
         rB0 = *pB0;
         rA1 = pA1[5];
         rA2 = pA2[5];
         rC2_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA3[5];
         rC3_0 += m3;
         m3 = rA1 * rB0;
         rC0_0 += m4;
         m4 = rA2 * rB0;
         rC1_0 += m5;
         m5 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[6];
         rB0 = *pB0;
         rA1 = pA1[6];
         rA2 = pA2[6];
         rC2_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[6];
         rC3_0 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m2;
         m2 = rA2 * rB0;
         rC1_0 += m3;
         m3 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[7];
         rB0 = *pB0;
         rA1 = pA1[7];
         rA2 = pA2[7];
         rC2_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA3[7];
         rC3_0 += m5;
         m5 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[8];
         rB0 = *pB0;
         rA1 = pA1[8];
         rA2 = pA2[8];
         rC2_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA3[8];
         rC3_0 += m3;
         m3 = rA1 * rB0;
         rC0_0 += m4;
         m4 = rA2 * rB0;
         rC1_0 += m5;
         m5 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[9];
         rB0 = *pB0;
         rA1 = pA1[9];
         rA2 = pA2[9];
         rC2_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[9];
         rC3_0 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m2;
         m2 = rA2 * rB0;
         rC1_0 += m3;
         m3 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[10];
         rB0 = *pB0;
         rA1 = pA1[10];
         rA2 = pA2[10];
         rC2_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA3[10];
         rC3_0 += m5;
         m5 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[11];
         rB0 = *pB0;
         rA1 = pA1[11];
         rA2 = pA2[11];
         rC2_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA3[11];
         rC3_0 += m3;
         m3 = rA1 * rB0;
         rC0_0 += m4;
         m4 = rA2 * rB0;
         rC1_0 += m5;
         m5 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[12];
         rB0 = *pB0;
         rA1 = pA1[12];
         rA2 = pA2[12];
         rC2_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[12];
         rC3_0 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m2;
         m2 = rA2 * rB0;
         rC1_0 += m3;
         m3 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[13];
         rB0 = *pB0;
         rA1 = pA1[13];
         rA2 = pA2[13];
         rC2_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA3[13];
         rC3_0 += m5;
         m5 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[14];
         rB0 = *pB0;
         rA1 = pA1[14];
         rA2 = pA2[14];
         rC2_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA3[14];
         rC3_0 += m3;
         m3 = rA1 * rB0;
         rC0_0 += m4;
         m4 = rA2 * rB0;
         rC1_0 += m5;
         m5 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[15];
         rB0 = *pB0;
         rA1 = pA1[15];
         rA2 = pA2[15];
         rC2_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[15];
         rC3_0 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m2;
         m2 = rA2 * rB0;
         rC1_0 += m3;
         m3 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[16];
         rB0 = *pB0;
         rA1 = pA1[16];
         rA2 = pA2[16];
         rC2_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA3[16];
         rC3_0 += m5;
         m5 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[17];
         rB0 = *pB0;
         rA1 = pA1[17];
         rA2 = pA2[17];
         rC2_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA3[17];
         rC3_0 += m3;
         m3 = rA1 * rB0;
         rC0_0 += m4;
         m4 = rA2 * rB0;
         rC1_0 += m5;
         m5 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[18];
         rB0 = *pB0;
         rA1 = pA1[18];
         rA2 = pA2[18];
         rC2_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[18];
         rC3_0 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m2;
         m2 = rA2 * rB0;
         rC1_0 += m3;
         m3 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[19];
         rB0 = *pB0;
         rA1 = pA1[19];
         rA2 = pA2[19];
         rC2_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA3[19];
         rC3_0 += m5;
         m5 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[20];
         rB0 = *pB0;
         rA1 = pA1[20];
         rA2 = pA2[20];
         rC2_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA3[20];
         rC3_0 += m3;
         m3 = rA1 * rB0;
         rC0_0 += m4;
         m4 = rA2 * rB0;
         rC1_0 += m5;
         m5 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[21];
         rB0 = *pB0;
         rA1 = pA1[21];
         rA2 = pA2[21];
         rC2_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[21];
         rC3_0 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m2;
         m2 = rA2 * rB0;
         rC1_0 += m3;
         m3 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[22];
         rB0 = *pB0;
         rA1 = pA1[22];
         rA2 = pA2[22];
         rC2_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA3[22];
         rC3_0 += m5;
         m5 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[23];
         rB0 = *pB0;
         rA1 = pA1[23];
         rA2 = pA2[23];
         rC2_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA3[23];
         rC3_0 += m3;
         m3 = rA1 * rB0;
         rC0_0 += m4;
         m4 = rA2 * rB0;
         rC1_0 += m5;
         m5 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[24];
         rB0 = *pB0;
         rA1 = pA1[24];
         rA2 = pA2[24];
         rC2_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[24];
         rC3_0 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m2;
         m2 = rA2 * rB0;
         rC1_0 += m3;
         m3 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[25];
         rB0 = *pB0;
         rA1 = pA1[25];
         rA2 = pA2[25];
         rC2_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA3[25];
         rC3_0 += m5;
         m5 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[26];
         rB0 = *pB0;
         rA1 = pA1[26];
         rA2 = pA2[26];
         rC2_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA3[26];
         rC3_0 += m3;
         m3 = rA1 * rB0;
         rC0_0 += m4;
         m4 = rA2 * rB0;
         rC1_0 += m5;
         m5 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[27];
         rB0 = *pB0;
         rA1 = pA1[27];
         rA2 = pA2[27];
         rC2_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[27];
         rC3_0 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m2;
         m2 = rA2 * rB0;
         rC1_0 += m3;
         m3 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[28];
         rB0 = *pB0;
         rA1 = pA1[28];
         rA2 = pA2[28];
         rC2_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA3[28];
         rC3_0 += m5;
         m5 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[29];
         rB0 = *pB0;
         rA1 = pA1[29];
         rA2 = pA2[29];
         rC2_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA3[29];
         rC3_0 += m3;
         m3 = rA1 * rB0;
         rC0_0 += m4;
         m4 = rA2 * rB0;
         rC1_0 += m5;
         m5 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[30];
         rB0 = *pB0;
         rA1 = pA1[30];
         rA2 = pA2[30];
         rC2_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[30];
         rC3_0 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m2;
         m2 = rA2 * rB0;
         rC1_0 += m3;
         m3 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[31];
         rB0 = *pB0;
         rA1 = pA1[31];
         rA2 = pA2[31];
         rC2_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA3[31];
         rC3_0 += m5;
         m5 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[32];
         rB0 = *pB0;
         rA1 = pA1[32];
         rA2 = pA2[32];
         rC2_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA3[32];
         rC3_0 += m3;
         m3 = rA1 * rB0;
         rC0_0 += m4;
         m4 = rA2 * rB0;
         rC1_0 += m5;
         m5 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[33];
         rB0 = *pB0;
         rA1 = pA1[33];
         rA2 = pA2[33];
         rC2_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[33];
         rC3_0 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m2;
         m2 = rA2 * rB0;
         rC1_0 += m3;
         m3 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[34];
         rB0 = *pB0;
         rA1 = pA1[34];
         rA2 = pA2[34];
         rC2_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA3[34];
         rC3_0 += m5;
         m5 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[35];
         rB0 = *pB0;
         rA1 = pA1[35];
         rA2 = pA2[35];
         rC2_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA3[35];
         rC3_0 += m3;
         m3 = rA1 * rB0;
         rC0_0 += m4;
         m4 = rA2 * rB0;
         rC1_0 += m5;
         m5 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[36];
         rB0 = *pB0;
         rA1 = pA1[36];
         rA2 = pA2[36];
         rC2_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[36];
         rC3_0 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m2;
         m2 = rA2 * rB0;
         rC1_0 += m3;
         m3 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[37];
         rB0 = *pB0;
         rA1 = pA1[37];
         rA2 = pA2[37];
         rC2_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA3[37];
         rC3_0 += m5;
         m5 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[38];
         rB0 = *pB0;
         rA1 = pA1[38];
         rA2 = pA2[38];
         rC2_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA3[38];
         rC3_0 += m3;
         m3 = rA1 * rB0;
         rC0_0 += m4;
         m4 = rA2 * rB0;
         rC1_0 += m5;
         m5 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[39];
         rB0 = *pB0;
         rA1 = pA1[39];
         rA2 = pA2[39];
         rC2_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[39];
         rC3_0 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m2;
         m2 = rA2 * rB0;
         rC1_0 += m3;
         m3 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[40];
         rB0 = *pB0;
         rA1 = pA1[40];
         rA2 = pA2[40];
         rC2_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA3[40];
         rC3_0 += m5;
         m5 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[41];
         rB0 = *pB0;
         rA1 = pA1[41];
         rA2 = pA2[41];
         rC2_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA3[41];
         rC3_0 += m3;
         m3 = rA1 * rB0;
         rC0_0 += m4;
         m4 = rA2 * rB0;
         rC1_0 += m5;
         m5 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[42];
         rB0 = *pB0;
         rA1 = pA1[42];
         rA2 = pA2[42];
         rC2_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[42];
         rC3_0 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m2;
         m2 = rA2 * rB0;
         rC1_0 += m3;
         m3 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[43];
         rB0 = *pB0;
         rA1 = pA1[43];
         rA2 = pA2[43];
         rC2_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA3[43];
         rC3_0 += m5;
         m5 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[44];
         rB0 = *pB0;
         rA1 = pA1[44];
         rA2 = pA2[44];
         rC2_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA3[44];
         rC3_0 += m3;
         m3 = rA1 * rB0;
         rC0_0 += m4;
         m4 = rA2 * rB0;
         rC1_0 += m5;
         m5 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[45];
         rB0 = *pB0;
         rA1 = pA1[45];
         rA2 = pA2[45];
         rC2_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[45];
         rC3_0 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m2;
         m2 = rA2 * rB0;
         rC1_0 += m3;
         m3 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[46];
         rB0 = *pB0;
         rA1 = pA1[46];
         rA2 = pA2[46];
         rC2_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA3[46];
         rC3_0 += m5;
         m5 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         pB0 += incBk;
         rA0 = pA0[47];
         rB0 = *pB0;
         rA1 = pA1[47];
         rA2 = pA2[47];
         rC2_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA3[47];
         rC3_0 += m3;
         m3 = rA1 * rB0;
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m4;
         m4 = rA2 * rB0;
         rC1_0 += m5;
         m5 = rA3 * rB0;
         pB0 += incBk;
         rC2_0 += m0;
         rC3_0 += m1;
         rC0_0 += m2;
         rC1_0 += m3;
         rC2_0 += m4;
         rC3_0 += m5;
         pA0 += incAk;
         pA1 += incAk;
         pA2 += incAk;
         pA3 += incAk;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pA2 += incAm;
         pA3 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pA3 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
