#ifdef ATL_UCLEANM
#define ATL_sJIK0x48x48TN48x48x0_a1_b1 ATL_sgpMBmm_b1
#else
#define ATL_sJIK0x48x48TN48x48x0_a1_b1 ATL_spMBmm_b1
#endif

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x48x48TN1x1x48_a1_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=48, KB=48, 
 * lda=48, ldb=48, ldc=0, mu=1, nu=1, ku=48, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   #define Mb M
   const float *stM = A + (((Mb) << 5)+((Mb) << 4));
   const float *stN = B + 2304;
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 48
   const int incAm = 0, incAn = -(((Mb) << 5)+((Mb) << 4));
   #define incBk 48
   const int incBm = -48, incBn = 48;
   const int incAk0 = ((incAk) / 48), incBk0 = ((incBk) / 48);
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float m0, m1, m2, m3;
   register float rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rC0_0 = *pC0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         m1 = rA0 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         m2 = rA0 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         m3 = rA0 * rB0;
         rA0 = pA0[4];
         rB0 = pB0[4];

/*
 *       Completely unrolled K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[17];
         rB0 = pB0[17];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[18];
         rB0 = pB0[18];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[19];
         rB0 = pB0[19];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rA0 = pA0[20];
         rB0 = pB0[20];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[21];
         rB0 = pB0[21];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[22];
         rB0 = pB0[22];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[23];
         rB0 = pB0[23];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rA0 = pA0[24];
         rB0 = pB0[24];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[25];
         rB0 = pB0[25];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[26];
         rB0 = pB0[26];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[27];
         rB0 = pB0[27];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rA0 = pA0[28];
         rB0 = pB0[28];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[29];
         rB0 = pB0[29];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[30];
         rB0 = pB0[30];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[31];
         rB0 = pB0[31];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rA0 = pA0[32];
         rB0 = pB0[32];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[33];
         rB0 = pB0[33];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[34];
         rB0 = pB0[34];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[35];
         rB0 = pB0[35];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rA0 = pA0[36];
         rB0 = pB0[36];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[37];
         rB0 = pB0[37];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[38];
         rB0 = pB0[38];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[39];
         rB0 = pB0[39];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rA0 = pA0[40];
         rB0 = pB0[40];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[41];
         rB0 = pB0[41];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[42];
         rB0 = pB0[42];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[43];
         rB0 = pB0[43];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rA0 = pA0[44];
         rB0 = pB0[44];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[45];
         rB0 = pB0[45];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[46];
         rB0 = pB0[46];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[47];
         rB0 = pB0[47];
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rC0_0 += m0;
         rC0_0 += m1;
         rC0_0 += m2;
         rC0_0 += m3;
         pA0 += incAk;
         pB0 += incBk;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x48x48TN48x48x0_a1_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=48, KB=48, 
 * lda=48, ldb=48, ldc=0, mu=3, nu=1, ku=48, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const int Mb = (M/3)*3;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((Mb) << 5)+((Mb) << 4));
   const float *stN = B + 2304;
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*3*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 48
   const int incAm = 96, incAn = -(((Mb) << 5)+((Mb) << 4));
   #define incBk 48
   const int incBm = -48, incBn = 48;
   const int incAk0 = ((incAk) / 48), incBk0 = ((incBk) / 48);
   #define incCm 3
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2;
   register float rB0;
   register float m0, m1, m2, m3;
   register float rC0_0, rC1_0, rC2_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rC0_0 = *pC0;
            rC1_0 = pC0[1];
            rC2_0 = pC0[2];
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[48];
            m0 = rA0 * rB0;
            rA2 = pA0[96];
            m1 = rA1 * rB0;
            m2 = rA2 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[49];
            rA2 = pA0[97];
            m3 = rA0 * rB0;

/*
 *          Completely unrolled K-loop
 */
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[50];
            rA2 = pA0[98];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[51];
            rA2 = pA0[99];
            rC2_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[52];
            rA2 = pA0[100];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            m2 = rA2 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[53];
            rA2 = pA0[101];
            rC2_0 += m3;
            m3 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[54];
            rA2 = pA0[102];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rA1 = pA0[55];
            rA2 = pA0[103];
            rC2_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rA1 = pA0[56];
            rA2 = pA0[104];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            m2 = rA2 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rA1 = pA0[57];
            rA2 = pA0[105];
            rC2_0 += m3;
            m3 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rA1 = pA0[58];
            rA2 = pA0[106];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rA1 = pA0[59];
            rA2 = pA0[107];
            rC2_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rA1 = pA0[60];
            rA2 = pA0[108];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            m2 = rA2 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rA1 = pA0[61];
            rA2 = pA0[109];
            rC2_0 += m3;
            m3 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rA1 = pA0[62];
            rA2 = pA0[110];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rA1 = pA0[63];
            rA2 = pA0[111];
            rC2_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rA1 = pA0[64];
            rA2 = pA0[112];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            m2 = rA2 * rB0;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rA1 = pA0[65];
            rA2 = pA0[113];
            rC2_0 += m3;
            m3 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rA1 = pA0[66];
            rA2 = pA0[114];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[19];
            rB0 = pB0[19];
            rA1 = pA0[67];
            rA2 = pA0[115];
            rC2_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rA0 = pA0[20];
            rB0 = pB0[20];
            rA1 = pA0[68];
            rA2 = pA0[116];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            m2 = rA2 * rB0;
            rA0 = pA0[21];
            rB0 = pB0[21];
            rA1 = pA0[69];
            rA2 = pA0[117];
            rC2_0 += m3;
            m3 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[22];
            rB0 = pB0[22];
            rA1 = pA0[70];
            rA2 = pA0[118];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[23];
            rB0 = pB0[23];
            rA1 = pA0[71];
            rA2 = pA0[119];
            rC2_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rA0 = pA0[24];
            rB0 = pB0[24];
            rA1 = pA0[72];
            rA2 = pA0[120];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            m2 = rA2 * rB0;
            rA0 = pA0[25];
            rB0 = pB0[25];
            rA1 = pA0[73];
            rA2 = pA0[121];
            rC2_0 += m3;
            m3 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[26];
            rB0 = pB0[26];
            rA1 = pA0[74];
            rA2 = pA0[122];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[27];
            rB0 = pB0[27];
            rA1 = pA0[75];
            rA2 = pA0[123];
            rC2_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rA0 = pA0[28];
            rB0 = pB0[28];
            rA1 = pA0[76];
            rA2 = pA0[124];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            m2 = rA2 * rB0;
            rA0 = pA0[29];
            rB0 = pB0[29];
            rA1 = pA0[77];
            rA2 = pA0[125];
            rC2_0 += m3;
            m3 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[30];
            rB0 = pB0[30];
            rA1 = pA0[78];
            rA2 = pA0[126];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[31];
            rB0 = pB0[31];
            rA1 = pA0[79];
            rA2 = pA0[127];
            rC2_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rA0 = pA0[32];
            rB0 = pB0[32];
            rA1 = pA0[80];
            rA2 = pA0[128];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            m2 = rA2 * rB0;
            rA0 = pA0[33];
            rB0 = pB0[33];
            rA1 = pA0[81];
            rA2 = pA0[129];
            rC2_0 += m3;
            m3 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[34];
            rB0 = pB0[34];
            rA1 = pA0[82];
            rA2 = pA0[130];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[35];
            rB0 = pB0[35];
            rA1 = pA0[83];
            rA2 = pA0[131];
            rC2_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rA0 = pA0[36];
            rB0 = pB0[36];
            rA1 = pA0[84];
            rA2 = pA0[132];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            m2 = rA2 * rB0;
            rA0 = pA0[37];
            rB0 = pB0[37];
            rA1 = pA0[85];
            rA2 = pA0[133];
            rC2_0 += m3;
            m3 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[38];
            rB0 = pB0[38];
            rA1 = pA0[86];
            rA2 = pA0[134];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[39];
            rB0 = pB0[39];
            rA1 = pA0[87];
            rA2 = pA0[135];
            rC2_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rA0 = pA0[40];
            rB0 = pB0[40];
            rA1 = pA0[88];
            rA2 = pA0[136];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            m2 = rA2 * rB0;
            rA0 = pA0[41];
            rB0 = pB0[41];
            rA1 = pA0[89];
            rA2 = pA0[137];
            rC2_0 += m3;
            m3 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[42];
            rB0 = pB0[42];
            rA1 = pA0[90];
            rA2 = pA0[138];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[43];
            rB0 = pB0[43];
            rA1 = pA0[91];
            rA2 = pA0[139];
            rC2_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rA0 = pA0[44];
            rB0 = pB0[44];
            rA1 = pA0[92];
            rA2 = pA0[140];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            m2 = rA2 * rB0;
            rA0 = pA0[45];
            rB0 = pB0[45];
            rA1 = pA0[93];
            rA2 = pA0[141];
            rC2_0 += m3;
            m3 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[46];
            rB0 = pB0[46];
            rA1 = pA0[94];
            rA2 = pA0[142];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[47];
            rB0 = pB0[47];
            rA1 = pA0[95];
            rA2 = pA0[143];
            rC2_0 += m1;
            m1 = rA0 * rB0;
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rC2_0 += m0;
            rC0_0 += m1;
            rC1_0 += m2;
            rC2_0 += m3;
            pA0 += incAk;
            pB0 += incBk;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_sJIK0x48x48TN1x1x48_a1_b1(k, 48, 48, alpha, ca + (((Mb) << 5)+((Mb) << 4)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
